#!/bin/bash

OS=$( uname -o )
if [[ $OS = "GNU/Linux" ]]; then
   SORT='sort -k 4nr -k 2 -k 3 '
   AWK=awk
else
   SORT='sort +3nr +1 +2'
   if [[ -x gawk ]]; then
      AWK=gawk
   elif [[ -x nawk ]]; then
      AWK=nawk
   else
      AWK=awk
   fi
fi

dbaccess sysmaster - <<EOF 2>/dev/null

unload to /tmp/systabnames.$$.unl delimiter ' '
select dbsname, tabname, partnum from systabnames order by 3;

unload to /tmp/lengths.$$.unl delimiter ' '
select max(length(dbsname)), max(length(tabname)) from systabnames;

EOF

read mdbs mtab </tmp/lengths.$$.unl

sed 's/\\//' /tmp/systabnames.$$.unl >/tmp/systabnames.$$.unl.clean
onstat -P >/tmp/onstat.P.$$.out
$AWK -v mdbs=$mdbs -v mtab=$mtab '
FILENAME ~ /.unl.clean/ {
    dbase[$3]=$1;
    tabnm[$3]=$2;
}

/Buffer pool page size/ {
    pgsz=$5/1024;
}

FILENAME ~ /.out/ {
    if (tabnm[$1] != "") {
        printf "%10d: %*.*s\t%*.*s\t%10d KB (%10d pages * %3d Kb/page).\n", $1, (mdbs * -1), mdbs, dbase[$1], (mtab * -1), mtab, tabnm[$1], $2*pgsz, $2, pgsz;
    }
} ' /tmp/systabnames.$$.unl.clean /tmp/onstat.P.$$.out | $SORT
rm /tmp/onstat.P.$$.out /tmp/systabnames.$$.unl.clean /tmp/systabnames.$$.unl /tmp/lengths.$$.unl

