#!/usr/bin/ksh
#

OS=$( uname -o )
if [[ $OS = "GNU/Linux" ]]; then
   SORT='sort -k 4nr -k 2 -k 3 '
   AWK=awk
else
   SORT='sort +3nr +1 +2'
   if [[ -x gawk ]]; then
      AWK=gawk
   elif [[ -x nawk ]]; then
      AWK=nawk
   else
      AWK=awk
   fi
fi

dbaccess sysmaster - <<EOF 2>/dev/null

unload to /tmp/systabnames.$$.unl delimiter ' '
select dbsname, tabname, partnum from systabnames order by 3;

unload to /tmp/lengths.$$.unl delimiter ' '
select max(length(dbsname)), max(length(tabname)) from systabnames;

EOF

read mdbs mtab </tmp/lengths.$$.unl

sed 's/\\//' /tmp/systabnames.$$.unl >/tmp/systabnames.$$.unl.clean

if [[ $# -eq 0 ]]; then
    onstat -P >/tmp/onstat.P.$$.out
    fil=/tmp/onstat.P.$$.out
    TEMP=1
else
    fil=$1
    TEMP=0
fi
$AWK -v mdbs=$mdbs '
FILENAME ~ /.unl.clean/ {
    dbase[$3]=$1;
    tabnm[$3]=$2;
}

/Buffer pool page size:/{ 
    psz=$5; 
    print "\nBuffer Pool Size: " psz;
    empty = 0; 
    delete cnt; 
    delete prt; 
}

$1 =="0" { empty= $2; }
$1 ~ "[1-9][0-9][0-9][0-9][0-9][0-9][0-9]" {
    cnt[$1] = $2;
    prt[$2] = $1;
}
/Totals/ {
    nhogs=0;
    Total=$2 - empty;
    asorti( prt, prt2, "@ind_num_desc" );
    for (count in prt2) {
        prtn = prt[prt2[count]];
    	if ((cnt[prtn] / Total) > 0.050) {
	   printf "\tTable: %s:%s hogs %6.3f%% of the %dK cache!\n", dbase[prtn], tabnm[prtn], ((100 *cnt[prtn]) / Total), psz; 
	   nhogs++;
	}
    }
    if (nhogs == 0) { print "\tNo hogs in this buffer pool!"; }
}
' /tmp/systabnames.$$.unl.clean $fil
rm /tmp/lengths.$$.unl /tmp/systabnames.$$.unl*
if [[ $TEMP -eq 1 ]]; then
    rm $fil
fi



