#!/usr/bin/bash
if [[ $# -ne 2 ]]; then
    echo "$0 databases tables"
    echo " "
    echo "   databases and tables can be MATCHES wildcards!"
    echo " "
    exit 1
fi

dbs=$1
tab=$2

if [[ $dbs = "all" ]]; then dbs='*'; fi
if [[ $tab = "all" ]]; then tab='*'; fi

dbaccess sysmaster - <<EOF 2>/dev/null
select st.dbsname, st.tabname, ceil( sum(pg_pagesize - pg_frcnt)/avg(pt.nrows))::int as avg_rowsize
from syspaghdr sp, sysptnhdr pt, systabnames st
where sp.pg_partnum = pt.partnum
    and st.partnum = pt.partnum
    and st.dbsname matches "$dbs"
    and st.tabname matches "$tab"
    and mod( sp.pg_flags, 2 ) = 1
group by 1, 2
;
EOF
