BEGIN{
    gain[2048] = 0;
    gain[4096] = 0;
    gain[6144] = 0;
    gain[8192] = 0;
    gain[10240] = 0;
    gain[12288] = 0;
    gain[14336] = 0;
    gain[16384] = 0;

    loss[2048] = 0;
    loss[4096] = 0;
    loss[6144] = 0;
    loss[8192] = 0;
    loss[10240] = 0;
    loss[12288] = 0;
    loss[14336] = 0;
    loss[16384] = 0;

    currfile="";
    fnr=0;
    npgszs=0;
}
currfile != FILENAME{
    fnr++;
    currfile = FILENAME;
}
/^Buffer pool page size:/{
    pgsz=$5;
    pagesize=pgsz;
    if (fnr == 1) {
        PageSizes[npgszs] = pgsz;
        npgszs++;
    }
}
length($0)==0{
    next;
}
/^IBM|^Buffer|^partnum|^Totals|^Percentages|^Data|^Btree|^Other/{
    next;
}
fnr == 1{
    partnum=$1
    npages=$2
    savePages[1,partnum] = npages;
    pages[1, pagesize] += npages;
}
fnr == 2{
    partnum=$1
    npages=$2
    savePages[2,partnum] = npages;
    pages[2, pagesize] += npages;

    if (npages > savePages[1,partnum]) {
        gain[pagesize] += (npages - savePages[1,partnum]);
    } else if (npages < savePages[1,partnum]) {
        loss[pagesize] += (savePages[1,partnum] - npages);
    }
}
END{

    for ( szix = 0; szix < npgszs; szix++ ) {
        pgsz=PageSizes[szix];
        printf "For Page Size %d: Total Pgs: %d  Gain: %d.\n", PageSizes[szix], pages[2,pgsz], gain[pgsz];
        printf "                                 Loss: %d.\n", loss[pgsz];
    }
}
