#! /bin/ksh
#
# Usage: dbsize database 
#
if [[ $# -eq 0 || $# -gt 1 ]]; then
    echo "Usage: ${0##*/} database "
    echo ""
    echo "    the databasename can be a matches compatible wildcard"
    echo ""
    exit 1
elif [[ $# -eq 1 ]]; then
    dbname=$1
fi
dbaccess sysmaster - <<EOF  2>/dev/null
select dbsname::char(30) AS database, (sum(size * pagesize)/1024)::BIGINT AS KB
from sysextents se, syschunks sc
where se.chunk = sc.chknum
  and dbsname matches "$dbname"
group by 1
order by 1;
EOF
