# onstat -g rah
onstat -|egrep '14\.10\..C7' >/dev/null 2>&1
if [[ $? -eq 1 ]]; then
   cmd='onstat -g rah'
   type='FC6'
else
   cmd='onstat -g rah partitions'
   type='FC7'
fi
echo "$cmd |awk -v type=$type"
$cmd |awk -v type=$type '
BEGIN{ 
	data=0; idx=0; idxdat=0; logs=0; lstcom=0;
	bufrds=0; dskrds=0;
	udata=0; uidx=0; uidxdat=0; ulogs=0; ulstcom=0;
	edata=0; eidx=0; eidxdat=0; elogs=0; elstcom=0;
	skip=1;
}
/^partnum/{skip=0;next;}
skip==1{next;}
/^0x/ && type=="FC7"{
	bufrds = bufrds+$2;dskrds=dskrds+$3;
	data=data+$6; idx=idx+$10; idxdat=idxdat+$14; logs=logs+$17; lstcom=lstcom=$13; prtpg=prtpg+$23;
	edata=$6;     eidx=$8;     eidxdat=$10;       elogs=$12;     elstcom=$14;       eprt=$26;
	udata=udata + int(($6 * ($8 / 100)) + 0.5);
	uidx=uidx + int(($10 * ($12 / 100) + 0.5));
	uidxdat=uidxdat + int(($14 * ($16 / 100)) + 0.5);
	ulogs=ulogs + int(($17 * ($19 / 100)) + 0.5);
	ulstcom=ulstcom + int(($20 ($21 / 100)) + 0.5);
	uprt   =urttcom + int(($26 ($28 / 100)) + 0.5);
	next;
}
/^0x/{
	bufrds = bufrds+$2;dskrds=dskrds+$3;
	data=data+$5; idx=idx+$7; idxdat=idxdat+$9; logs=logs+$11; lstcom=lstcom=$13;
	edata=$6;     eidx=$8;    eidxdat=$10;      elogs=$12;     elstcom=$14
	udata=udata + int(($5 * ($6 / 100)) + 0.5);
	uidx=uidx + int(($7 * ($8 / 100) + 0.5));
	uidxdat=uidxdat + int(($9 * ($10 / 100)) + 0.5);
	ulogs=ulogs + int(($11 * ($12 / 100)) + 0.5);
	ulstcom=ulstcom + int(($13 * ($14 / 100)) + 0.5);
	next;
}
END{ 
        printf "data   = %10.1d  Used data   = %10.1d  Data Utilization:   %10.3f\n", data, udata, data ? (udata / data) * 100.00 : 0.00;
	printf "idx    = %10.1d  Used idx    = %10.1d  Idx Utilization:    %10.3f\n", idx, uidx, idx ? (uidx / idx) * 100.00 : 0.00;
	printf "idxdat = %10.1d  Used idxdat = %10.1d  Idxdat Utilization: %10.3f\n", idxdat, uidxdat, idxdat ? (uidxdat / idxdat) * 100.00 : 0.00;
	printf "logs   = %10.1d  Used logs   = %10.1d  Logs Utilization:   %10.3f\n", logs, ulogs, logs ? (ulogs / logs) * 100.00 : 0.00;
	printf "lstcom = %10.1d  Used lstcom = %10.1d  Lstcom Utilization: %10.3f\n", lstcom, ulstcom, lstcom ? (ulstcom / lstcom) * 100.00 : 0.00;
	printf "\tTot RA = %10.1d  Used RA     = %10.1d  \n", (data+idx+idxdat+logs+lstcom), (udata+uidx+uidxdat+ulogs+ulstcom)
	printf "Overall RAU:  %10.5f%\n",(data+idx+idxdat+logs+lstcom) ? (udata+uidx+uidxdat+ulogs+ulstcom)/(data+idx+idxdat+logs+lstcom) * 100 : 0;
	printf "\nbufrds = %10.1d\ndskrds = %10.1d\n", bufrds, dskrds;
	printf "Cache Pct:      %7.3f\n\n", bufrds ? (100 - ((dskrds / bufrds) * 100)) : 0.00;
}
'
