#! /bin/ksh
#
# Usage: tabsize database [tabname]
#
if [[ $# -eq 0 || $# -gt 2 ]]; then
    echo "Usage: ${0##*/} database [tabname]"
    echo ""
    echo "    the tabname can be a matches compatible wildcard"
    echo ""
    exit 1
elif [[ $# -eq 1 ]]; then
    dbname=$1
    tabname='*'
elif [[ $# -eq 2 ]]; then
    dbname=$1
    tabname=$2
fi

dbaccess sysmaster - <<EOF  2>/dev/null
select (TRIM(dbsname)||'.'||TRIM(tabname))::char(50) AS table, ((sum(size * pagesize)/1024)::BIGINT) AS KB
from sysextents se, syschunks sc
where se.chunk = sc.chknum
  and se.dbsname = "$dbname"
  and se.tabname matches "$tabname"
group by 1
order by 1;
EOF
